#include "led.h"
#include <iostream>

wxDECLARE_APP(MyApp);

bool MyApp::OnInit()
{
	if (!wxApp::OnInit())
		return false;
	wxImage::AddHandler(new wxPNGHandler);
	this->frame = new MainFrame(this->get_kotai_id());
	this->frame->Show();

	return true;
}

int MyApp::FilterEvent(wxEvent &event)
{
	if (event.GetEventType() == wxEVT_KEY_DOWN) {
		if (WXK_RETURN == ((wxKeyEvent &) event).GetKeyCode()) {
			this->frame->enter_key_pressed();
			return 1;
		}
	}
	if (event.GetEventType() == wxEVT_KEY_UP) {
		if (WXK_RETURN == ((wxKeyEvent &) event).GetKeyCode()) {
			this->frame->enter_key_released();
			return 1;
		}
	}
	return -1;
}


int MyApp::OnExit()
{
	return 0;
}

std::string MyApp::get_kotai_id()
{
	FILE *fp;
	char buf[32];
	std::string cmd = "cat /sys/bus/nvmem/devices/imx-ocotp0/nvmem | hexdump -v -s 0xa0 -n 8 -e '/4 \"%08X\"' | cut -c 5-8 | tr -d '\n'";

	if ((fp = popen(cmd.c_str(), "r")) == NULL) {
		return "";
	}
 
	while (!feof(fp)) {
		fgets(buf, sizeof(buf), fp);
	}

	pclose(fp);

	return std::string(buf);
}

wxIMPLEMENT_APP(MyApp);
