#include "wx/wx.h"
#include "wx/image.h"
#include "wx/statbmp.h"
#include "wx/button.h"
#include "led_controller.h"
#include <string>

#define KOTAI_ID_A640_ES	"0097"
#define KOTAI_ID_A640		"009C"
#define KOTAI_ID_A610_ES	"00B4"
#define KOTAI_ID_A610		"00B7"

class MainFrame: public wxFrame
{
public:
	static const int LED_RED_ID = 0;
	static const int LED_YELLOW_ID = 1;

	MainFrame(std::string kotai_id);
	virtual ~MainFrame();
	void OnClose(wxCloseEvent& event);
	void button_pressed(wxCommandEvent &event);
	void enter_key_pressed();
	void enter_key_released();
	void update_led_image();

private:
	wxPanel *panel;
	wxPanel *image_panel;
	wxPanel *button_panel;
	wxStaticBitmap *board_canvas;
	wxStaticBitmap *led_canvas;
	wxStaticBitmap *sw_canvas;
	wxButton *red_button;
	wxButton *yellow_button;
	LEDController led_controller;
	std::string led_images[4];
	std::string kotai_id;
	DECLARE_EVENT_TABLE()
};

